/* btree.h */
/* definice tridy b-strom */

#include <stdio.h>

/* CBTree - vse potrebne */

class CBTree
{
	public:
		// constructor a destructor
		CBTree(CBTree *p_next, CBTree *p_prev);
		virtual ~CBTree();

		// verejne metody, jen to, co uzivatelum staci :)
		int insert_num(int number); // vlozit cislo do stromu
		int delete_num(int number); // vymazat cislo ze stromu
		void dump_structure(int n, FILE *file_out); // vytisknout zavorkovanou strukturu
		void dump_numbers(int n, FILE *file_out); // vytisknout serazena cisla
	
	private:	
		// sem nam nehrabte ...
		void delete_split(CBTree *p_page); // vymazani cisla ze stromu - slucovani
		void insert_split(int number, CBTree *p_page); // vlozeni cisla do stromu - rozdelovani
		int smallest(CBTree **p_p_page); // nejmensi cislo
		int biggest(CBTree **p_p_page); // nejvetsi cislo
		int find_smallest(); // najdi pozici nejmensiho
		int find_biggest(); // najdi pozici nejvetsiho
		void leaf_underflow(int number); // osetreni podteceni listu
		void page_underflow(int number); // osetreni podteceni stranky
		int find_pos(int number); // kde je pozice cisla
	
		int no_data; // pocet ulozenych cisel
		int *p_data; // sem se ukladaji cisla
		CBTree *p_prev;	 // predchozi stranka
		CBTree **p_p_next; // nasledujici stranka
};

typedef CBTree *P_CBTREE;
extern P_CBTREE p_root;
extern int N; // rad b-stromu
